function Put = blackscholes(sptprice, strike, rate, volatility, time)
    logterm = log10(sptprice / strike);
    powterm = 0.5 .* volatility .* volatility;
    den = volatility .* sqrt(time);
    d1 = (((rate + powterm) .* time) + logterm) / den;
    d2 = d1 - den;
    NofXd1 = cndf2(d1);
    NofXd2 = cndf2(d2);	
    futureValue = strike .* exp(- rate .* time);
    c1 = futureValue .* NofXd2;
    Call = sptprice .* NofXd1 - c1;
    Put  = Call - futureValue + sptprice;
end

function Out = cndf2(In)
    Out = 0.5 + 0.5 * erf(0.707106781 * In);
end

