iterations = 100000000;

sptprice = zeros(1,iterations);
initStrike = zeros(1,iterations);
rate = zeros(1,iterations);
volatility = zeros(1,iterations);
time = zeros(1,iterations);

sptprice(:) = 42.0;
for  i=1:iterations
    initStrike(i) = 40.0 + (i / iterations);
end
rate(:) = 0.5;
volatility(:) = 0.2;
time(:) = 0.5;

tic;
put = blackscholes(sptprice, initStrike, rate, volatility, time);
t = toc;
fprintf('checksum: %.9f\n', sum(put));
fprintf('Rate = %f Opts/sec\n', iterations / t)
fprintf('SELFTIMED %.9f\n', t)
