if exist('infile') == 0
  infile  = 'sample.jpg';
end
C = strsplit(infile, '.');
C(1) = strcat(C(1), '-blur');
outfile = strjoin(C, '.');
if exist('iterations') == 0
  iterations = 1;
end
fprintf('input file = %s\n', infile);
fprintf('iterations = %d\n', iterations);
fprintf('output file = %s\n', outfile);
img = imread(infile);
buf = single(img) ./ 255.0;
tic;
w = size(buf, 1);
h = size(buf, 2);
for i = 1:iterations
    buf(3:w-2,3:h-2) = ...
        buf(3-2:w-4,3-2:h-4) * 0.003  + buf(3-1:w-3,3-2:h-4) * 0.0133 + buf(3:w-2,3-2:h-4) * 0.0219 + buf(3+1:w-1,3-2:h-4) * 0.0133 + buf(3+2:w,3-2:h-4) * 0.0030 + ...
        buf(3-2:w-4,3-1:h-3) * 0.0133 + buf(3-1:w-3,3-1:h-3) * 0.0596 + buf(3:w-2,3-1:h-3) * 0.0983 + buf(3+1:w-1,3-1:h-3) * 0.0596 + buf(3+2:w,3-1:h-3) * 0.0133 + ...
        buf(3-2:w-4,3+0:h-2) * 0.0219 + buf(3-1:w-3,3+0:h-2) * 0.0983 + buf(3:w-2,3+0:h-2) * 0.1621 + buf(3+1:w-1,3+0:h-2) * 0.0983 + buf(3+2:w,3+0:h-2) * 0.0219 + ...
        buf(3-2:w-4,3+1:h-1) * 0.0133 + buf(3-1:w-3,3+1:h-1) * 0.0596 + buf(3:w-2,3+1:h-1) * 0.0983 + buf(3+1:w-1,3+1:h-1) * 0.0596 + buf(3+2:w,3+1:h-1) * 0.0133 + ...
        buf(3-2:w-4,3+2:h-0) * 0.003  + buf(3-1:w-3,3+2:h-0) * 0.0133 + buf(3:w-2,3+2:h-0) * 0.0219 + buf(3+1:w-1,3+2:h-0) * 0.0133 + buf(3+2:w,3+2:h-0) * 0.0030;
end
time = toc;
img = uint8(buf .* 255.0);
imwrite(img, outfile);
fprintf('SELFTIMED %.9f\n', time);


