# Run using something like:
# ./benchmark.sh 1> totaltimes.log 2> offloadtimes.log

# This will produce two files that can be processed with
# util/munge-results.py:

# ../../util/munge-results.py totaltimes.log offloadtimes.log

NUM_TRIALS=5

echo "BENCHMARK NAME: Harris corner detection" >&2
echo "BENCHMARK DESCRIPTION: 8000x8000 source image" >&2
echo "BENCHMARK SHORT NAME: harris" >&2

echo "Version: @acc (36 threads):" >&2
for ((i=1; i<=NUM_TRIALS; i++)); do OMP_NUM_THREADS=36 ./runjulia5-acc.sh; done

echo "Version: @acc (1 thread):" >&2
for ((i=1; i<=NUM_TRIALS; i++)); do OMP_NUM_THREADS=1 ./runjulia5-acc.sh; done

echo "Version: Julia 0.5 (1 thread):" >&2
for ((i=1; i<=NUM_TRIALS; i++)); do ./runjulia5.sh; done

echo "Version: Matlab:" >&2
for ((i=1; i<=NUM_TRIALS; i++)); do ./runmatlab.sh; done

echo "Version: Matlab (1 thread):" >&2
for ((i=1; i<=NUM_TRIALS; i++)); do ./runmatlab-single.sh; done



