# Laplace 6-point 3D stencil

## Implementations

  * laplace.m: MATLAB version.
  * See the examples directory in the ParallelAccelerator package for the `@acc` and plain Julia versions.  The plain Julia version is a naively written nested loop that does condition check in the inner loop to handle both borders and interior.
  * laplace3d.c: Various C implementations; see comments in the file.
  * laplace3d-threads.jl: Alternate Julia implementation using @threads (explicit threading).

## Notes

`size` is a natural number that indicates the image is a 3D array of `size * size * size`,
and `iterations` is a natural number that indicates how many steps the stencil is repeated.

If not specified, the default is `size` = 290 and `iterations` = 1000.  The size of 290 is because, for the C version, each dimension needs to be 4n+2 for SSE or 8n+2 for AVX.


