// Barrier
//
//////////////////////////////////////////////////////////////////////


#ifndef _BARRIER_
#define _BARRIER_


//#define DELAY {asm __volatile__ ("delay %[cycle]" :: [cycle] "r" (10));}
#define DELAY 


#define PAD (16)
#define GROUP (4)
typedef struct {
volatile __declspec(align(4096)) unsigned _TREE_BARRIER_TURN_[256*PAD];
volatile __declspec(align(4096)) unsigned _TREE_BARRIER_FLAG_0[4][256*PAD];
volatile __declspec(align(4096)) unsigned _TREE_BARRIER_COUNT_0[4][256*PAD];
volatile __declspec(align(4096)) unsigned _TREE_BARRIER_FLAG_1[4][256*PAD];
volatile __declspec(align(4096)) unsigned _TREE_BARRIER_COUNT_1[4][256*PAD];
} TREE_BARRIER_TYPE;

inline void TREE_BARRIER_INIT(TREE_BARRIER_TYPE *TREE_BARRIER)
{
    for (int i = 0; i < 256; i++)
    {
        TREE_BARRIER->_TREE_BARRIER_TURN_[i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_0[0][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_0[1][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_0[2][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_0[3][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_0[0][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_0[1][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_0[2][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_0[3][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_1[0][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_1[1][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_1[2][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_FLAG_1[3][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_1[0][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_1[1][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_1[2][i*PAD] = 0;
        TREE_BARRIER->_TREE_BARRIER_COUNT_1[3][i*PAD] = 0;
    }
}

#ifdef TARGET_ATTRIBUTE
TARGET_ATTRIBUTE
#endif
inline void TREE_BARRIER(TREE_BARRIER_TYPE *TREE_BARRIER, int ID, int MAX)
{
    if (TREE_BARRIER->_TREE_BARRIER_TURN_[ID*PAD] == 0)
    {
        TREE_BARRIER->_TREE_BARRIER_TURN_[ID*PAD] = 1;
        int LEVEL = 0;
        int STRIDE = 1;
        int MASK = GROUP - 1;
        while (1)
        {
            int WAITER = ID & MASK;
            int SUBSET = ID & (~MASK);
            if (WAITER)
            {
                TREE_BARRIER->_TREE_BARRIER_COUNT_0[LEVEL][ID*PAD] = 1;
                while(TREE_BARRIER->_TREE_BARRIER_FLAG_0[LEVEL][SUBSET*PAD] == 0) DELAY;
                while (LEVEL > 0)
                {
                    LEVEL--;
                    TREE_BARRIER->_TREE_BARRIER_FLAG_1[LEVEL][ID*PAD] = 0;
                    TREE_BARRIER->_TREE_BARRIER_FLAG_0[LEVEL][ID*PAD] = 1;
                }
                break;
            }
            else
            {
                int CHILD = ID + STRIDE;
                for (int SET = 1; (SET < GROUP) && (CHILD < MAX); SET++)
                {
                    while(TREE_BARRIER->_TREE_BARRIER_COUNT_0[LEVEL][CHILD*PAD] == 0) DELAY;
                    TREE_BARRIER->_TREE_BARRIER_COUNT_1[LEVEL][CHILD*PAD] = 0;
                    CHILD += STRIDE;
                }

                LEVEL++;
                STRIDE *= GROUP;
                MASK *= GROUP;
                if (STRIDE >= MAX)
                {
                    while (LEVEL > 0)
                    {
                        LEVEL--;
                        TREE_BARRIER->_TREE_BARRIER_FLAG_1[LEVEL][ID*PAD] = 0;
                        TREE_BARRIER->_TREE_BARRIER_FLAG_0[LEVEL][ID*PAD] = 1;
                    }
                    break;
                }
            }
        }
    }
    else
    {
        TREE_BARRIER->_TREE_BARRIER_TURN_[ID*PAD] = 0;
        int LEVEL = 0;
        int STRIDE = 1;
        int MASK = GROUP - 1;
        while (1)
        {
            int WAITER = ID & MASK;
            int SUBSET = ID & (~MASK);
            if (WAITER)
            {
                TREE_BARRIER->_TREE_BARRIER_COUNT_1[LEVEL][ID*PAD] = 1;
                while(TREE_BARRIER->_TREE_BARRIER_FLAG_1[LEVEL][SUBSET*PAD] == 0) DELAY;
                while (LEVEL > 0)
                {
                    LEVEL--;
                    TREE_BARRIER->_TREE_BARRIER_FLAG_0[LEVEL][ID*PAD] = 0;
                    TREE_BARRIER->_TREE_BARRIER_FLAG_1[LEVEL][ID*PAD] = 1;
                }
                break;
            }
            else
            {
                int CHILD = ID + STRIDE;
                for (int SET = 1; (SET < GROUP) && (CHILD < MAX); SET++)
                {
                    while(TREE_BARRIER->_TREE_BARRIER_COUNT_1[LEVEL][CHILD*PAD] == 0) DELAY;
                    TREE_BARRIER->_TREE_BARRIER_COUNT_0[LEVEL][CHILD*PAD] = 0;
                    CHILD += STRIDE;
                }

                LEVEL++;
                STRIDE *= GROUP;
                MASK *= GROUP;
                if (STRIDE >= MAX)
                {
                    while (LEVEL > 0)
                    {
                        LEVEL--;
                        TREE_BARRIER->_TREE_BARRIER_FLAG_0[LEVEL][ID*PAD] = 0;
                        TREE_BARRIER->_TREE_BARRIER_FLAG_1[LEVEL][ID*PAD] = 1;
                    }
                    break;
                }
            }
        }
    }
}

#define N1_BARRIER(BARRIER, ID, MAX) TREE_BARRIER(BARRIER, (ID-1), (MAX-1))

#undef PAD
#undef GROUP


#endif
