#include <mkl_vsl.h>
#include <cstdio>

#define CheckVSL(expr) ((expr)==VSL_STATUS_OK? (void)0 : (std::fprintf(stderr,"file %s, line %d: %s failed\n",__FILE__,__LINE__,#expr),abort()))

inline void genGaussian(VSLStreamStatePtr stream, int num, float* z, float mean, float stddev) {
    CheckVSL( vsRngGaussian(VSL_RNG_METHOD_GAUSSIAN_ICDF, stream, num, z, mean, stddev) );
}

inline void genGaussian(VSLStreamStatePtr stream, int num, double* z, double mean, double stddev) {
    CheckVSL( vdRngGaussian(VSL_RNG_METHOD_GAUSSIAN_ICDF, stream, num, z, mean, stddev) );
}
