
function [amerpayoffput,finalputpayoff] = model(strike, numPaths, numSteps, asset)
    avgPathFactor = 1.0/numPaths;
    putpayoff = max(strike - asset(:,numSteps+1), 0.0);
    cashFlowPut = putpayoff * avgPathFactor;
    % Now go back in time using regression
    for s = numSteps:-1:2
        curasset = asset(:,s);
        vcond = curasset <= strike;
        valPut0 =  zeros(numPaths,1);
        valPut0(vcond) = 1.0;
        
        valPut1 = valPut0 .* curasset; % assetval
        valPut2 = valPut1 .* valPut1;  % assetval ^ 2
        valPut3 = valPut2 .* valPut1;  % assetval ^ 3
        valPut4 = valPut2 .* valPut2;  % assetval ^ 4
        % compute the regression
        ridgecorrect = 0.01;
        sum0 = sum(valPut0)+ridgecorrect;
        sum1 = sum(valPut1)+ridgecorrect;
        sum2 = sum(valPut2)+ridgecorrect;
        sum3 = sum(valPut3)+ridgecorrect;
        sum4 = sum(valPut4)+ridgecorrect;
        sqrtest = [sum0 sum1 sum2; sum1 sum2 sum3; sum2 sum3 sum4]; 
        invsqr = inv(sqrtest);
        vp0 = dot(cashFlowPut, valPut0);
        vp1 = dot(cashFlowPut, valPut1);
        vp2 = dot(cashFlowPut, valPut2);
        betaPut = [vp0 vp1 vp2] * invsqr;
        regImpliedCashFlow = valPut0 .* betaPut(1) + valPut1 .* betaPut(2) + valPut2 .* betaPut(3);
        payoff = valPut0 .* (strike - curasset);
        pcond = payoff > regImpliedCashFlow;
        cashFlowPut(pcond) = payoff(pcond);
    end

    amerpayoffput = sum(cashFlowPut)/numPaths;
    finalputpayoff = sum(putpayoff)/numPaths;
end



