

spot = 100.0;
strike = 110.0;
vol = 0.25;
maturity = 2.0;

rng(0);

numPaths = 131072*4;
numSteps = 256;

dt = maturity / numSteps;
volSqrtdt = vol*sqrt(dt);
fwdFactor = vol^2*dt*-0.5;
vsqrtdt_log2e = volSqrtdt * log2(exp(1.0));
fwdFactor_log2e = fwdFactor* log2(exp(1.0));

asset = zeros(numPaths, numSteps+1);
asset(:,1) = spot;
for s=2:numSteps+1
	asset(:,s) = asset(:,s-1) .* 2.^(fwdFactor_log2e + vsqrtdt_log2e .* randn(numPaths,1)); 
end

tic;
[amerpayoffput, finalputpayoff] = model(strike, numPaths, numSteps, asset);
selftimed = toc;
fprintf('European Put Option Price: %.9f\n',finalputpayoff);
fprintf('American Put Option Price: %.9f\n',amerpayoffput);
fprintf('SELFTIMED %.9f\n', selftimed);


