# A dummy function that we can compile before running
# ParallelAccelerator.  Alternative to using embed.

# Longer explanation: The point of this file is that it can be
# included before benchmarking ParallelAccelerator code so that a
# dummy function can be compiled and run.  This will trigger the
# compilation of the entire ParallelAccelerator package (which takes
# ~30 seconds), so that that time (the time that Julia takes to
# compile PA) won't be included in the compilation time we measure for
# ParallelAccelerator to compile the target code.

using ParallelAccelerator

@acc __dummy_fn__(A::Array{Float64,2}, B::Array{Float64,2}) = begin
    runStencil((a, b) -> a[0,0] = b[0,0], A, B, 1, :oob_skip)
    2 .+ (A.*B)
end

tic()
 __dummy_fn__([[2.0, 2.0] [2.0, 2.0]], [[2.0, 2.0] [2.0, 2.0]])
println("Package compilation time: ", toq())
