#!/bin/bash

### Run in host mode unless otherwise specified.
export PROSPECT_MODE="host"

### JULIA_0_5_EXE should point to your Julia 0.5 executable.
export JULIA_0_5_EXE="/usr/local/bin/julia"

### Add directory containing MATLAB executable to PATH.
export PATH="$PATH:/usr/local/bin/matlab"

export JULIA_PKGDIR="${HOME}/.julia"

### If ReadFromEnv is enabled, our own env var settings will be used,
### instead of whatever's specified in the code for a given benchmark.
export ReadFromEnv=1 

### Turn all optimizations on.
export PIRNumThreadsMode=0
export PIRInplace=1
export PIRHoistAllocation=1
export PIRBbReorder=1
export PIRSetFuseLimit=-1
export vectorizationlevel=2

export KMP_AFFINITY=scatter
export OMP_NESTED=1

### Number of physical cores on your machine.  On macOS, change this
### to `sysctl -n hw.ncpu`.
export NUM_CORES=`grep -c ^processor /proc/cpuinfo`
